//
//  AppDelegate.swift
//  N80X
//
//  Created by hiroshi on 2021/08/20.
//

import Cocoa
import GameController

@main
class AppDelegate: NSObject, NSApplicationDelegate {
    fileprivate var bmpimg:DblBuffBmpImage! = nil
    fileprivate let keyboard:GCKeyboard! = nil
    fileprivate var n80:n80em! = nil

    internal var BmpImg:DblBuffBmpImage {
        return self.bmpimg
    }
    internal var N80EM:n80em {
        return self.n80
    }
    
    public func reqInit() {
        self.bmpimg = DblBuffBmpImage(640, 400)
        self.n80 = n80em(dma: self.bmpimg, bootROM: 0, penalty: 0, interrace: true)
    }
    
    func applicationDidFinishLaunching(_ aNotification: Notification) {
        // Insert code here to initialize your application
    }

    func applicationWillTerminate(_ aNotification: Notification) {
        // Insert code here to tear down your application
        self.n80.reqDispose()
    }
    
    @IBAction func menuTenkeyLess(_ sender: Any) {
        self.n80.n80kb.toggle_tenkeyless()
    }
    
    @IBAction func menuQuit(_ sender: Any) {
        NSApplication.shared.terminate(self)
    }
  
    @IBAction func menuReset(_ sender: Any) {
        self.n80.reqReset()
    }
    
    @IBAction func menuPCG(_ sender: Any) {
        self.n80.reqPCGToggle()
    }
    
    @IBAction func menuInterrace(_ sender: NSMenuItem) {
        if sender.state == NSControl.StateValue.on {
            sender.state = NSControl.StateValue.off
            self.n80.n80gr.chg_palette(false)
        } else {
            sender.state = NSControl.StateValue.on
            self.n80.n80gr.chg_palette(true)
        }
    }
    
    @IBAction func menuOpen(_ sender: Any) {
        self.n80.reqOpenFile()
    }
}

